=== debian/changelog ===
opm-simulators (2023.04+ds-1) unstable; urgency=medium

  * New upstream release candidate 2023.04
  * d/control: New dependency on libhdf5-mpi-dev
  * d/control: Use standards version 4.6.2
  * Added missing include of cstdint needed by GCC-13
      (Closes: #1037811)
  * d/control: Added missing build dependency on bc.
      (Closes: #1038600)
  * Fixed spelling: achive -> achieve.

 -- Markus Blatt <markus@dr-blatt.de>  Sun, 16 Jul 2023 17:12:42 +0200

opm-simulators (2022.10+ds-3) unstable; urgency=medium

  * d/control: Limit the architectures to known working ones.

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 23 Mar 2023 08:35:44 +0100
