## opm-simulators 2024.04+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,9 +13,9 @@
 
 # Mandatory call to project
 
+cmake_minimum_required (VERSION 3.10)
+
 project(opm-simulators C CXX)
-
-cmake_minimum_required (VERSION 3.10)
 
 
 option(SIBLING_SEARCH "Search for other modules in sibling directories?" ON)
@@ -31,6 +31,8 @@
 option(USE_CHOW_PATEL_ILU_GPU_PARALLEL "Try to use more parallelism on the GPU during the iterative ILU decomposition? Requires USE_CHOW_PATEL_ILU_GPU" OFF)
 option(BUILD_FLOW_ALU_GRID "Build flow blackoil with alu grid" OFF)
 option(USE_DAMARIS_LIB "Use the Damaris library for asynchronous I/O?" OFF)
+option(USE_BDA_BRIDGE "Enable the BDA bridge (GPU/AMGCL solvers)" ON)
+option(USE_TRACY_PROFILER "Enable tracy profiling" OFF)
 
 # The following was copied from CMakeLists.txt in opm-common.
 # TODO: factor out the common parts in opm-common and opm-simulator as a cmake module
@@ -100,6 +102,10 @@
 
 if(USE_MPI)
   set(HDF5_PREFER_PARALLEL TRUE)
+endif()
+
+if(USE_BDA_BRIDGE)
+  set(COMPILE_BDA_BRIDGE 1)
 endif()
 
 # not the same location as most of the other projects? this hook overrides
@@ -170,7 +176,6 @@
 
 if(CUDA_FOUND)
   set(HAVE_CUDA 1)
-  set(COMPILE_BDA_BRIDGE 1)
   include_directories(${CUDA_INCLUDE_DIRS})
 endif()
 
@@ -182,7 +187,6 @@
   find_file(CL2_HPP CL/cl2.hpp HINTS ${OpenCL_INCLUDE_DIRS})
   if(CL2_HPP)
     set(HAVE_OPENCL 1)
-    set(COMPILE_BDA_BRIDGE 1)
     include_directories(${OpenCL_INCLUDE_DIRS})
     find_file(OPENCL_HPP CL/opencl.hpp HINTS ${OpenCL_INCLUDE_DIRS})
     if(OPENCL_HPP)
@@ -216,7 +220,6 @@
 find_package(amgcl)
 if(amgcl_FOUND)
   set(HAVE_AMGCL 1)
-  set(COMPILE_BDA_BRIDGE 1)
   # Linking to target angcl::amgcl drags in OpenMP and -fopenmp as a compile
   # flag. With that nvcc fails as it does not that flag.
   # Hence we set AMGCL_INCLUDE_DIRS.
@@ -228,7 +231,6 @@
   find_package(VexCL)
   if(VexCL_FOUND)
     set(HAVE_VEXCL 1)
-    set(COMPILE_BDA_BRIDGE 1)
     # generator expressions in vexcl do not seem to work and therefore
     # we cannot use the imported target. Hence we exract the needed info
     # from the targets
@@ -254,8 +256,13 @@
   opm_need_version_of ("opm-models")
 
   if(NOT fmt_FOUND)
-    add_definitions(-DFMT_HEADER_ONLY)
-    list(APPEND EXTRA_INCLUDES SYSTEM ${PROJECT_SOURCE_DIR}/external/fmtlib/include)
+    include(DownloadFmt)
+  endif()
+  if(USE_TRACY_PROFILER AND Tracy_FOUND)
+    set(USE_TRACY 1)
+    list(APPEND opm-simulators_LIBRARIES Tracy::TracyClient)
+  else()
+    set(USE_TRACY)
   endif()
   include_directories(${EXTRA_INCLUDES})
 
@@ -279,5 +286,3 @@
   if(hip_FOUND)
     get_filename_component(CXX_COMPILER ${CMAKE_CXX_COMPILER} NAME)
     if(hip_VERSION VERSION_LESS "5.3")
-      if(ROCALUTION_FOUND AND NOT CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
-        message(WARNING " Cannot use hipcc/clang for rocalution with rocm < 5.3\n Disabling rocalutionSolver")
