=== debian/changelog ===
opm-simulators (2024.04+ds-3) unstable; urgency=medium

  * add missing include to fix build with gcc-14
    (Closes: #1075350)

 -- Markus Blatt <markus@dr-blatt.de>  Wed, 17 Jul 2024 14:02:06 +0200

opm-simulators (2024.04+ds-2) unstable; urgency=medium

  * d/control: depend on OPM >= 2024.04

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 13 May 2024 13:13:09 +0200

opm-simulators (2024.04+ds-1) unstable; urgency=medium

  * New upstream release 2024.04.

 -- Markus Blatt <markus@dr-blatt.de>  Wed, 08 May 2024 21:28:23 +0200

opm-simulators (2024.04~rc2+ds-2) unstable; urgency=medium

  * Prevent pybind11 from stripping debug symbols
  * Depend on OPM >= 2024.04~
  * New upstream release candidate 2024.04~rc2.
  * Build-Depends: pkg-config => pkgconf
  * d/rules: Require 7 GB per process building.

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 07 May 2024 22:13:47 +0200

opm-simulators (2024.04~rc2+ds-1) experimental; urgency=medium

  * Prevent pybind11 from stripping debug symbols
  * New upstream release candidate 2024.04~rc2.

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 06 May 2024 18:02:59 +0200

opm-simulators (2024.04~rc1+ds-1) experimental; urgency=medium

  * New upstream release candidate 2024.04~rc1
  * Depend on OPM >= 2024.04~

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 19 Apr 2024 20:21:18 +0200

opm-simulators (2023.10+ds-3) unstable; urgency=medium

  * Fixed failing test test_LogOutputHelper on ppc64el

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 01 Apr 2024 19:47:56 +0200

opm-simulators (2023.10+ds-2) unstable; urgency=medium

  * Team upload.
  * Add support for loong64
    Closes: #1059848
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)

 -- Andreas Tille <tille@debian.org>  Sun, 18 Feb 2024 17:11:46 +0100

opm-simulators (2023.10+ds-1) experimental; urgency=medium

  * New upstream release 2023.10
  * d/copyright: Update copyright.
  * d/control: Depend on final OPM 2023.10

 -- Markus Blatt <markus@dr-blatt.de>  Sun, 12 Nov 2023 17:14:33 +0100

opm-simulators (2023.10~rc2+ds-1) experimental; urgency=medium

  * New upstream release candidate 2023.10-rc2

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 30 Oct 2023 20:50:37 +0100

opm-simulators (2023.10~rc1+ds-1) experimental; urgency=medium

  * New upstream release candidate 2023.10-rc1
  * d/watch; Also allow downloading upstream release candidates

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 17 Oct 2023 21:38:33 +0200
