=== debian/control ===
--- 
+++ 
@@ -2,26 +2,26 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
-Build-Depends: debhelper-compat (= 12), cmake (>=3.10), quilt, dh-python, bc,
+Build-Depends: debhelper-compat (= 13), quilt, dh-sequence-python3, bc,
                libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
-               zlib1g-dev, gfortran, pkg-config, lsb-release, libtool, doxygen,
+               zlib1g-dev, gfortran, pkgconf, lsb-release, libtool, doxygen,
                texlive-latex-extra, texlive-latex-recommended, ghostscript,
-               libopm-grid-dev (>= 2023.04), libopm-models-dev (>= 2023.04),
+               libopm-grid-dev (>= 2024.04), libopm-models-dev (>= 2024.04),
 	       mpi-default-dev, mpi-default-bin, python3-dev, libpython3-dev,
-	       python3-distutils, pybind11-dev, libhdf5-mpi-dev
+	       pybind11-dev, libhdf5-mpi-dev
 Standards-Version: 4.6.2
 Section: libs
-Homepage: http://opm-project.org
+Homepage: https://opm-project.org
 Vcs-Browser: https://salsa.debian.org/science-team/opm-simulators
 Vcs-Git: https://salsa.debian.org/science-team/opm-simulators.git
 Rules-Requires-Root: no
 
 Package: libopm-simulators-dev
 Section: libdevel
-Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64
+Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
 Multi-Arch: same
-Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2023.04),
-         libopm-models-dev (>= 2023.04), libboost-date-time-dev
+Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2024.04),
+         libopm-models-dev (>= 2024.04), libboost-date-time-dev
 Replaces: libopm-simulators1-dev
 Suggests: libopm-simulators-doc
 Description: Parallel porous media / reservoir simulators -- development files
@@ -42,7 +42,7 @@
 
 Package: libopm-simulators
 Pre-Depends: ${misc:Pre-Depends}
-Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64
+Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
 Provides: ${opm:shared-library}
@@ -67,7 +67,7 @@
 Package: libopm-simulators-bin
 Section: science
 Pre-Depends: ${misc:Pre-Depends}
-Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64
+Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Replaces: libopm-simulators1-bin
@@ -113,7 +113,7 @@
 Package: python3-opm-simulators
 Section: python
 Pre-Depends: ${misc:Pre-Depends}
-Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64
+Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
 #Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, libopm-simulators
 Recommends: python3-opm-common
