## opm-simulators 2024.10%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,7 @@
 set( USE_OPENMP_DEFAULT OFF ) # Use of OpenMP is considered experimental
 option(BUILD_FLOW "Build the production oriented flow simulator?" ON)
 option(BUILD_FLOW_VARIANTS "Build the variants for flow by default?" OFF)
+option(BUILD_FLOW_FLOAT_VARIANTS "Build the variants for flow using float?" OFF)
 option(BUILD_FLOW_POLY_GRID "Build flow blackoil with polyhedral grid" OFF)
 option(OPM_ENABLE_PYTHON "Enable python bindings?" OFF)
 option(OPM_ENABLE_PYTHON_TESTS "Enable tests for the python bindings?" ON)
@@ -33,6 +34,42 @@
 option(USE_DAMARIS_LIB "Use the Damaris library for asynchronous I/O?" OFF)
 option(USE_BDA_BRIDGE "Enable the BDA bridge (GPU/AMGCL solvers)" ON)
 option(USE_TRACY_PROFILER "Enable tracy profiling" OFF)
+option(CONVERT_CUDA_TO_HIP "Convert CUDA code to HIP (to run on AMD cards)" OFF)
+set(OPM_COMPILE_COMPONENTS "2;3;4;5;6;7" CACHE STRING "The components to compile support for")
+
+# Ensure OPM_COMPILE_COMPONENTS is a list of at least one element
+if(OPM_COMPILE_COMPONENTS STREQUAL "")
+  message(FATAL_ERROR "OPM_COMPILE_COMPONENTS must contain at least one component.")
+endif()
+# Check that OPM_COMPILE_COMPONENTS is a subset of 2,3,4,5,6,7
+set(valid_components "2;3;4;5;6;7")
+foreach(component IN LISTS OPM_COMPILE_COMPONENTS)
+  list(FIND valid_components ${component} index)
+  if(index EQUAL -1)
+    message(FATAL_ERROR "Invalid component ${component} in OPM_COMPILE_COMPONENTS. Valid components are: ${valid_components}")
+  endif()
+endforeach()
+# Check for duplicates in OPM_COMPILE_COMPONENTS
+list(REMOVE_DUPLICATES OPM_COMPILE_COMPONENTS)
+# Make a string we can use in the code
+# this will be used in a template argument pack.
+string(REPLACE ";" "," OPM_COMPILE_COMPONENTS_TEMPLATE_LIST "${OPM_COMPILE_COMPONENTS}")
+
+
+# HIP requires cmake version 3.21
+if (CONVERT_CUDA_TO_HIP AND CMAKE_VERSION VERSION_GREATER_EQUAL "3.21")
+  enable_language(HIP)
+  message("CUDA code will be hipified")
+  set(HAVE_CUDA 1) # we still need this defined so that the preprocessor does not remove the code
+  set(CUDA_FOUND ON)
+  set(USE_HIP 1)
+  find_package(hip REQUIRED)
+  find_package(hipsparse REQUIRED)
+  find_package(hipblas REQUIRED)
+  link_libraries(roc::hipblas roc::hipsparse)
+elseif(CONVERT_CUDA_TO_HIP)
+  message("To generate HIP code for AMD GPUs run CMake with version >= 3.21")
+endif()
 
 # The following was copied from CMakeLists.txt in opm-common.
 # TODO: factor out the common parts in opm-common and opm-simulator as a cmake module
@@ -166,6 +203,7 @@
     # Hence we call it unconditionally
     # The WellContributions kernel uses __shfl_down_sync, which was introduced in CUDA 9.0
     find_package(CUDA)
+    set(CUDA_FOUND ON)
   endif()
   if(CUDA_FOUND AND CUDA_VERSION VERSION_LESS "9.0")
     set(CUDA_FOUND OFF)
@@ -174,9 +212,13 @@
   endif()
 endif()
 
+find_package(CUDAToolkit)
 if(CUDA_FOUND)
   set(HAVE_CUDA 1)
-  include_directories(${CUDA_INCLUDE_DIRS})
+  if(NOT USE_HIP) # no need to include CUDA files if we use rocm stack
+    include_directories(${CUDA_INCLUDE_DIRS})
+    include_directories(${CUDAToolkit_INCLUDE_DIRS})
+  endif()
 endif()
 
 find_package(OpenCL)
@@ -231,58 +273,3 @@
   find_package(VexCL)
   if(VexCL_FOUND)
     set(HAVE_VEXCL 1)
-    # generator expressions in vexcl do not seem to work and therefore
-    # we cannot use the imported target. Hence we exract the needed info
-    # from the targets
-    get_property(VEXCL_INCLUDE_DIRS TARGET VexCL::Common PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
-    get_property(VEXCL_LINK_LIBRARIES TARGET VexCL::Common PROPERTY INTERFACE_LINK_LIBRARIES)
-    get_property(VEXCL_COMPILE_DEFINITIONS TARGET VexCL::OpenCL PROPERTY INTERFACE_COMPILE_DEFINITIONS)
-    set(VEXCL_LINK_LIBRARIES "${VEXCL_LINK_LIBRARIES};OpenCL::OpenCL")
-    add_library(OPM::VexCL::OpenCL INTERFACE IMPORTED)
-    set_target_properties(OPM::VexCL::OpenCL PROPERTIES
-      INTERFACE_COMPILE_DEFINITIONS "${VEXCL_COMPILE_DEFINITIONS}"
-      INTERFACE_LINK_LIBRARIES "${VEXCL_LINK_LIBRARIES}")
-    target_include_directories(OPM::VexCL::OpenCL SYSTEM INTERFACE "${VEXCL_INCLUDE_DIRS}")
-  endif()
-endif()
-
-
-macro (config_hook)
-  opm_need_version_of ("dune-common")
-  opm_need_version_of ("dune-istl")
-  if(dune-fem_FOUND)
-      opm_need_version_of ("dune-fem")
-  endif()
-  opm_need_version_of ("opm-models")
-
-  if(NOT fmt_FOUND)
-    include(DownloadFmt)
-  endif()
-  if(USE_TRACY_PROFILER AND Tracy_FOUND)
-    set(USE_TRACY 1)
-    list(APPEND opm-simulators_LIBRARIES Tracy::TracyClient)
-  else()
-    set(USE_TRACY)
-  endif()
-  include_directories(${EXTRA_INCLUDES})
-
-  include(UseDamaris)
-endmacro (config_hook)
-
-macro (prereqs_hook)
-endmacro (prereqs_hook)
-
-macro (sources_hook)
-  if(OPENCL_FOUND)
-    include(opencl-source-provider)
-    list(APPEND opm-simulators_SOURCES ${PROJECT_BINARY_DIR}/clSources.cpp)
-  endif()
-endmacro (sources_hook)
-
-macro (fortran_hook)
-endmacro (fortran_hook)
-
-macro (files_hook)
-  if(hip_FOUND)
-    get_filename_component(CXX_COMPILER ${CMAKE_CXX_COMPILER} NAME)
-    if(hip_VERSION VERSION_LESS "5.3")
