## opm-simulators 2024.10+ds

=== debian/changelog ===
opm-simulators (2024.10+ds-6) unstable; urgency=medium

  * d/Control: Bumped standard version to 4.7.2 (no change)
  * d/control: Fixed syntax error in license

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 04 Apr 2025 17:57:40 +0200

opm-simulators (2024.10+ds-5) unstable; urgency=medium

  * Backported patches from upstream to support libfmt-dev >=11.1

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 14 Feb 2025 17:10:29 +0100

opm-simulators (2024.10+ds-4) unstable; urgency=medium

  * Add python3-opm-common as a dependency of libopm-simulators-dev
  * Force binary rebuild to fix failed builds for "python3.13 as default"
    transition because of messed build environmen (no change needed).
    (Closes: 1091426)

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 09 Jan 2025 17:15:22 +0100

opm-simulators (2024.10+ds-3) unstable; urgency=medium

  * d/patches: Install all needed headers.
  * d/copyright: Added paragraph with Boost Software License 1.0
  * d/libopm-simulators.lintian-overrides: Fix typo in pkg name.

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 21 Nov 2024 16:53:28 +0100

opm-simulators (2024.10+ds-2) unstable; urgency=medium

  * d/patches: Use upper case for COMPONENTS of FindSuiteSparse

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 18 Nov 2024 23:46:21 +0100

opm-simulators (2024.10+ds-1) unstable; urgency=medium

  * New upstream version 2024.10+ds-1
  * d/control: Depend on OPM 2024.10
  * d/control: Bumped standards version to 4.7.0
  * Use chrpath to strip RPATH/RUNPATH from installed libs/executables.
  * Refreshed patches
  * d/patches: Prepare for upcoming DUNE 2.10 release
  * d/control: Reflect the merge of opm-models with opm-simulators
  * d/copyright: Update and corrected copyright.
  * d/patches: Backported copyright declaration fix from upstream.

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 15 Nov 2024 15:22:44 +0100
