## opm-simulators 2025.04~rc3+ds

=== debian/changelog ===
opm-simulators (2025.04~rc3+ds-2) experimental; urgency=medium

  * Prevent pybind11 from stripping-debug-symbols

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 29 Apr 2025 13:22:21 +0200

opm-simulators (2025.04~rc3+ds-1) experimental; urgency=medium

  * New upstream pre-release 2025.04~rc3

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 29 Apr 2025 10:48:33 +0200

opm-simulators (2025.04~rc2+ds-1) experimental; urgency=medium

  * New upstream pre-release 2025.04~rc2

 -- Markus Blatt <markus@dr-blatt.de>  Wed, 16 Apr 2025 14:42:58 +0200

opm-simulators (2025.04~git20250402.2fa0ad149+ds-1~exp1) experimental; urgency=medium

  * Prelease reversion for upcomon 2025.04
  * Drop patches applied upstream
  * d/control: Depend on OPM 2025.04
  * d/control: Bumped standard version to 4.7.2 (no change)
  * d/control: Fixed formatting of license

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 03 Apr 2025 15:45:25 +0200
