## opm-simulators 2025.04%2Bds

=== debian/changelog ===
opm-simulators (2025.04+ds-2) unstable; urgency=medium

  * Fix quadmath problems on ppc64el with IEEE long double (Closes: #1114005)

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 18 Sep 2025 09:58:15 +0200

opm-simulators (2025.04+ds-1) unstable; urgency=medium

  * New upstream release version 2025.04
  * Drop patches applied upstream
  * d/control: Depend on OPM 2025.04
  * d/control: Bumped standard version to 4.7.2 (no change)
  * d/control: Fixed formatting of license
  * Prevent pybind11 from stripping-debug-symbols

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 11 Aug 2025 18:14:05 +0200
